//sci_hterm.c
//sciʐMpCu
//t@C:quckey3_test6.c
//2005/12/16

#include	"reg3664.h"

#define PMR1 IO.PMR1.BYTE
//#define SMR SCI3.SMR.BYTE
//#define BRR SCI3.BRR
//#define SCR3 SCI3.SCR3.BYTE 
//#define SSR SCI3.SSR.BYTE
//#define TDR SCI3.TDR

//sci
void sci_init()
{
	int i;
	PMR1 |= 0x02;
	SMR = 0;
	BRR = 25;
	SCR3 = 0;
	for(i = 0;i < 200;i++)
		asm("nop");
	SCR3 = 0x30;
	SSR = 0x80;
}

//sciňꕶM
void sci_putchar(long int c)
{
	while (!(SSR & 0x80));
	TDR = c;
}

//sciŕ񑗐M
void sci_print(const char *str)
{
	while (*str)
		sci_putchar(*str++);
}

//sci10i\
void sci_putdec(int c)
{
	int n;
	char tmp[10];

	for (n = 0; c && n < 9; n++) {
		tmp[n] = '0' + c % 10;
		c /= 10;
	}
	if (!n) tmp[n++] = 0;

	while (n > 0) {
		sci_putchar(tmp[--n]);
	}
}

//sci16i\(2)
void sci_puthex2(int c)
{
	static char hex[] = "0123456789abcdef";

	sci_putchar(hex[(c >> 4) & 15]);
	sci_putchar(hex[c & 15]);
}

//sci16i\(4)
void sci_puthex4(int c)
{
	static char hex[]= "0123456789abcdef";
	
	sci_putchar(hex[(c>>12) & 15]);
	sci_putchar(hex[(c>>8 ) & 15]);
	sci_putchar(hex[(c>>4 ) & 15]);
	sci_putchar(hex[c &15]);
}

//sciōsς
void sci_putcrlf()
{
	sci_putchar('\r');
	sci_putchar('\n');
}

//sci2i\(1)
void sci_put01(int c)
{
	static char onoff[]= "01";
	
	sci_putchar(onoff[c& 1]);
}
